from uuid import UUID

from db.repositories import TypeRepository
from .schemas import TypeSchema


class TypeService:
    type_repository = TypeRepository()

    async def get_type_list(self, **kwargs):
        types = await self.type_repository.get_list(**kwargs)
        return [TypeSchema.model_validate(type) for type in types]

    async def get_type(self, id: UUID):
        type = await self.type_repository.get(id)
        return TypeSchema.model_validate(type)

    async def create_type(self, **kwargs):
        type = await self.type_repository.create(**kwargs)
        return TypeSchema.model_validate(type)

    async def update_type(self, id: UUID, **kwargs):
        type = await self.type_repository.update(id, **kwargs)
        return TypeSchema.model_validate(type)

    async def delete_type(self, id: UUID):
        return await self.type_repository.delete(id)
